/*
DB2DB : Provides database functionality for DB2
    Copyright (C) 2001 Sunita Sarawagi

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 1, or (at your option)
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

package cube;

import util.*;
import java.sql.*;

public class DB2DB extends DB {
    static {
	try {
	    // register the driver with DriverManager
	    Class.forName("COM.ibm.db2.jdbc.net.DB2Driver").newInstance();
	} catch (Exception e) {
	    e.printStackTrace();
	}
    }	
    DB2DB(String dbname, String userid, String passwd, boolean debug) throws SQLException {
	_dbname = dbname;
	// URL is jdbc:db2:dbname
	String url = "jdbc:db2:" + dbname;
	// con = DriverManager.getConnection(url);
	// connect with user-provided username and password
	con = DriverManager.getConnection(url, userid, passwd);
	_debug = debug;
	MyOut.println("Connect to database " + url);
	getStmtMethod = null;
    }
    DB2DB(String dbname) throws SQLException {
	// URL is jdbc:db2:dbname
	String url = "jdbc:db2:" + dbname;
	// con = DriverManager.getConnection(url);
	// connect with user-provided username and password
	con = DriverManager.getConnection(url);
	//	MyOut.println("Connect to database " + url);
	getStmtMethod = null;
    }

    public String dbType() { return "DB2";}
    public void createTempTable(String tabname, String schema)   throws Exception {
	executeUpdate("create table " + tabname + schema + " not logged initially "); 
    }
    public void createUnloggedTable(String tabname, String schema) throws Exception  {
	executeUpdate("create table " +  tabname + schema + " not logged initially ");
    }
    public void executeUpdate(String st, String asSuffix) throws SQLException {
	executeUpdate(st + asSuffix);
    }

    public boolean tableExists(String tabname) {
	String st = "select tabname from syscat.tables where tabname = "
	    + "'" + tabname.toUpperCase() + "'";
	try {	
	    ResultSet rs = executeQuery(st);
	    if (rs != null) {
		boolean retval = rs.next();
		cursorClose(rs);
		return retval;
	    }
	    return false;
	} catch (Exception e) {
	    e.printStackTrace();
	}
	return false;
    }
};
