/*
Alg : Calculating mean square error
    Copyright (C) 2001 Sunita Sarawagi

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 1, or (at your option)
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

package diff;

class Alg {
    static final double LARGE_RATIO = 100;
    static final double SMALL_RATIO = 0.01;

    double _avgDescLen;
    public static String msgValSub() 
    {return "(case when v1 = 0 then 1/v2 else v1 end)";}
    public static double msgValSub(double v1, double v2) 
    // {return (v1 < Double.MIN_VALUE)?1/(v2+1):v1;}
    {return (v1 < Double.MIN_VALUE)?Math.min(v2, 1.0/(Math.log(v2+1))):v1;}
    public void setDataDescLen (double avgLen) {_avgDescLen = avgLen;}
    public double avgDataDescLen()  {return _avgDescLen;}
    int numDerived()  {return 3;}
    String derivedCols()  {return ", f1, f2, f3";}
    public String deriveddCols(int i)  {return "f"+String.valueOf(i+1);}
    public   String derivedCalcs()  {
	return ", sum(v1*v1) as f1, sum(v1*v2) as f2, sum(v2*v2) as f3 ";
    }
    public   String filterClause( double ratio)  {
	double descLen = avgDataDescLen();
	String sratio = String.valueOf(ratio);
	String mean = "c1*" + sratio;
	return "(c2-" + mean + ")*(c2-" + mean + ")/("+mean + ") + log(6.28*" + mean + ") > 2*numNulls*" + String.valueOf(descLen);
    }
    //    public AlgType type()  {return SQ_ERR;}
    public void calcDerivedCols(double _v1, double _v2, double _dvals[]) {
	_dvals[0] = _v1*_v1;
	_dvals[1] = _v1*_v2;
	_dvals[2] = _v2*_v2;
    }
    public double error(double _v1, double _v2, int cnt, double _dvals[], double r) {
		double b =  _v2;
	double a =  _v1;

	if ((a <= Double.MIN_VALUE) && (b <= Double.MIN_VALUE)) 
	    // empty tuple..
	    return 0;
	if ((a <= Double.MIN_VALUE) && (r == LARGE_RATIO))
	    // aggregation of missing values.
	    return 0;
	if ((b <= Double.MIN_VALUE) && (r == 0))
	    // aggregation of missing values.
	    return 0;
	return Math.sqrt(Math.max(r*r*_dvals[0] - 2*r*_dvals[1] + _dvals[2], 0));
    }
    public double errorRatio(double _v1, double _v2, int cnt, double _dvals[], double r) {
	return error(_v1,_v2,cnt, _dvals,r)/_v2;
    }
    public double getRatio(double v1, double v2) {
    if (v2 < Double.MIN_VALUE) return 0;
	return (v1 > Double.MIN_VALUE)?(v2/v1):LARGE_RATIO;
    }
};
