/*
ICubeServer : Initializing the ICube server
    Copyright (C) 2001 Sunita Sarawagi, IIT Bombay

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 1, or (at your option)
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

package main;

import cube.*;
import util.*;

import java.rmi.*;
import java.util.*;

public interface ICubeServer extends java.rmi.Remote
{
    public Cube newCube(String cubeName, String usr, String passwd) 
	throws RemoteException, Exception;
     public Cube newCube(String cubeName, String usr, String passwd, String provider) 
	throws RemoteException, Exception;
    public CubeData subCube(Term t, int axis1, int axis2)  
	throws RemoteException, Exception;

    // interfaces for the diff operator
    public Result getDiff(Vector attrNames1, Vector attrVals1, Vector attrNames2, Vector attrVals2)  
	throws RemoteException, Exception;
    public Result getDiff(Term firstTerm, Term secondTerm, Term aggLevel ) 
	throws RemoteException, Exception;
    public Result getDiff(Result res) 
	throws RemoteException, Exception;
    public void setDiffParams(String opts)  
	throws RemoteException;

    // interfaces for the relax operator.
    public void setRelaxParams(String opts)   
	throws RemoteException;
    public Result relax(Vector attrNames1, Vector attrVals1, Vector attrNames2, Vector attrVals2) 
	throws RemoteException, Exception;
    public Result relax(MTerm firstTerm, MTerm secondTerm ) 
	throws RemoteException, Exception;


    // interfaces for the maxent operator.

    /*------------------------------------------------
     * Maxent not provided in this release. Sept 2001
     */
    /*
    public void setMaxentParams(String opts)   
	throws RemoteException;
    public double markSeen(Vector attrNames, Vector attrVals) 
	throws RemoteException, Exception;
    public double markSeen(Term t) 
	throws RemoteException, Exception;
    public Result topNSurprises() 
	throws RemoteException, Exception; 
    public float getInformationContentPercent() 
	throws RemoteException, Exception; 
    public Term informativeNeibr(Term t) 
	throws RemoteException, Exception; 
    public InfoResult memberInfoQuery(Term dimLvl, Term memLvl, boolean sortOrder, int k) 
	throws RemoteException, Exception; 
    */
}




