/*
RelaxKLDist : Calculates error according to the KL distance function
    Copyright (C) 2001 Gayatri Sathe

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 1, or (at your option)
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

package relax;

import diff.*;

class RelaxKLDist extends KLDist {
	float specRatio = 1;
	
	RelaxKLDist(float mul){
		specRatio = mul;
	}

	public double error(double _v1, double _v2, int cnt, double _dvals[], double r) {
	     double error = (super.error(_v1,_v2,cnt,_dvals,r) + super.error(_v1,_v2,cnt,_dvals,specRatio));	
	     return error;
	}
}
