/*
BitSetPlus : Provides some additional functions over BitSet
    Copyright (C) 2001 Sunita Sarawagi

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 1, or (at your option)
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

package util;

import java.util.*;

// provides some more functions 
public class BitSetPlus implements java.io.Serializable  {
    java.util.BitSet v = null;
    int cnt;
    static BitSetPlus tmp = new BitSetPlus();
    public BitSetPlus() {v = new BitSet();}
    public BitSetPlus(int sz) {v = new BitSet(sz);}
    public BitSet bitset() {return v;}
    public int length() {
	for (int i = v.size()-1; i >= 0; i--)
	    if (v.get(i))
		return i+1;
	return 0;
    } 
    public boolean get(int i) {return v.get(i);}
    public void set(int i) { v.set(i);}
    public void or(BitSetPlus v2) {v.or(v2.bitset());}
    public void and(BitSetPlus v2) {v.and(v2.bitset());}
    public void clear(int i) {v.clear(i);}
    public String toString() {return v.toString();}
    public boolean equals(Object obj) {return v.equals(obj);}
    public boolean equals(BitSetPlus v2) {return v.equals(v2.bitset());}
    public void setCount(int c) {cnt = c;}
    public int count() {return cnt;}
    public void clear() {
	int len = length();
	for (int i = 0; i < len; i++) 
	    clear(i);
    }
    public void copy(BitSetPlus b) {
	clear();
	or(b);
    }
    int firstBitSet(){
	int len = length();
	for (int i=0; i< len; i++) 
	    if (get(i)) 
		return i;
	return -1;
    }
    public int numOnes() {
	int cnt = 0;
	int len = length();
	for (int i = 0; i < len; cnt += (get(i)?1:0), i++);
	return cnt;
    }
    // return true is this bitset subsumes b2 
    public boolean subsumes(BitSetPlus b2) {
	tmp.copy(this);
	tmp.and(b2);
	if (tmp.equals(b2))
	    return true;
	return false;
    }
}
