/*
IterGenC : Takes a subcube and sorts the tuples in the attriute ordering specified
    Copyright (C) 2001 Sunita Sarawagi

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 1, or (at your option)
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

package util;

import java.util.*;
import cube.*;

public class IterGenC implements IterGen {
    Cube cube;
    TermDesc tdesc;
    Term t1, t2;
    int[] sortOrder;
    public IterGenC(Cube c, Term tt1, Term tt2, TermDesc td) {
	cube = c;
	tdesc  = td;
	t1 = tt1;
	t2 = tt2;
	sortOrder = new int[t1.numAttrs()];
    } 
    public Iter getIter(int[] order)  throws Exception {
	if (order != null) {
	    for (int i = 0; i < tdesc.size(); i++) {
		sortOrder[i] = MdUtils.attrIndex(t1.termDescr(), tdesc.desc(order[i])); 
	    } 
	} else {
	    for (int i = 0; i < tdesc.size(); i++)
		sortOrder[i] = MdUtils.attrIndex(t1.termDescr(), tdesc.desc(i));
	}
	if (tdesc.size() < t1.numAttrs())
	    sortOrder[tdesc.size()] = -1;

	return new RelDataIter(
			       cube.executeQuery(cube.concatCubes(t1, t2,tdesc, 
			  new MeasureExpr("sum("+cube.measure(0)+")","v0"),
			  new MeasureExpr("sum("+cube.measure(0)+")","v1"),
			  sortOrder)), tdesc);
    }
    public TermDesc termDesc() {return tdesc;}
} 





