/*
SkipDataIter : 
    Copyright (C) 2001 Sunita Sarawagi

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 1, or (at your option)
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

package util;
import java.sql.*;

public class SkipDataIter extends RelDataIter {
    ETerm detTup, aggTup;
    public SkipDataIter(CubeRows rset, TermDesc tdesc) {
	super(rset, tdesc);
	detTup = new ETerm(tdesc);
	aggTup = new ETerm(tdesc);
    }
    void readRow() {
	try {
	    int col = 1;
	    for (int i = 0; i < nattrs; i++)
		aggTup.setVal(_rs.getObject(col++),i);
	    for (int i = 0; i < nattrs; i++)
		detTup.setVal(_rs.getObject(col++),i);
	    detTup.setMeasures(_rs.getDouble(col++), _rs.getDouble(col++));
	}  catch (Exception e) {
	    e.printStackTrace();
	}
    }
    public boolean moreETerms() {
	try {
	    if (tup.isEqual(detTup,null)) {
		if (!_rs.next()) 
		    return false;
		// first tuple, perhaps.
		readRow();
	    }
	    tup.copy(detTup);
	    int maxNumNonAggs = 0;
	    while ((tup.isEqual(detTup,null)) && _rs.next()) {
		if (maxNumNonAggs < aggTup.numNonAgg()) {
		    maxNumNonAggs = aggTup.numNonAgg();
		    tup.copyMeasures(detTup);
		}
		readRow();
	    }
	    return true;
	}  catch (Exception e) {
	    e.printStackTrace();
	}
	return false;
    }
    public ETerm getTuple() {
	ntups++;
	return tup;
    }
    public void getTuple(ETerm thisTup) {
	ntups++;
	thisTup.copy(tup);
    }
};
