/*
TimeKeeper : Measures the execution for a particular task
    Copyright (C) 2001 Sunita Sarawagi

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 1, or (at your option)
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

package util;

import java.util.*;

public class TimeKeeper {
    String _desc;
    long startTime;
    long totalTime;
    
    public TimeKeeper(String desc) {
	_desc = desc;
	init();
    }
    long currTime() {return (new Date()).getTime();}
    public void init() {totalTime = 0; start();}
    public void start() {startTime = currTime();}
    public void stop() {totalTime += (currTime() - startTime); }
    public String toString() {return _desc + ": " + totalTime + " ms";}
}
